package org.springblade.service;

import org.springblade.mapper.ApiTypeMapper;
import org.springblade.entity.ApiType;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class ApiTypeService {

    @Resource
    private ApiTypeMapper apiTypeMapper;

    public ApiType findApiTypeById(Integer id){
        return apiTypeMapper.findById(id);
    }

    public ApiType findApiTypeByName(String name) {
        return apiTypeMapper.findByName(name);
    }


    public boolean insertApiType(ApiType apiType) {
        return apiTypeMapper.insert(apiType);
    }

    public boolean updateApiType(ApiType apiType) {
        return apiTypeMapper.update(apiType);
    }

    public boolean deleteApiTypeById(Integer id) {
        return apiTypeMapper.deleteById(id);
    }

    public List<ApiType> listApiTypes(String tag) {
        return apiTypeMapper.listApiTypes(tag);
    }
}
