package org.springblade.service;

import org.springblade.mapper.AppApiMapper;
import org.springblade.entity.AppApi;
import org.springblade.entity.GeneralService;
import org.springblade.entity.SelectTimes;
import org.springblade.entity.SelectUserTimes;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class AppApiService {

    @Resource
    private AppApiMapper appApiMapper;

    public AppApi findAppApiById(Integer id){
        return appApiMapper.findById(id);
    }

    public AppApi findAppApiByName(String name) {
        return appApiMapper.findByName(name);
    }


    public boolean insertAppApi(AppApi appApi) {
        return appApiMapper.insert(appApi);
    }

    public boolean updateAppApi(AppApi appApi) {
        return appApiMapper.update(appApi);
    }

    public boolean deleteAppApiById(Integer id) {
        return appApiMapper.deleteById(id);
    }

    public List<AppApi> listAppApis(String tag) {
        return appApiMapper.listAppApis(tag);
    }

    public List<AppApi> listAll() {
        return appApiMapper.listAll();
    }

    public List<AppApi> listAppApisByAppId(Integer appId,Long userId) {
        return appApiMapper.listAppApisByAppId(appId,userId);
    }

    public List<AppApi> listAllMyApis(Long userId) {
        return appApiMapper.listAllMyApis(userId);
    }

    public List<AppApi> listAppApisByApiId(Integer appId) {
        return appApiMapper.listAppApisByApiId(appId);
    }

    public boolean deleteAppApisByAppId(Integer id) {
        return appApiMapper.deleteAppApisByAppId(id);
    }

    public List<GeneralService> selectGeneralService(Long userId) {
        return appApiMapper.selectGeneralService(userId);
    }

    public List<SelectTimes> selectTimes(Integer appId) {
        return appApiMapper.selectTimes(appId);
    }

    public List<SelectUserTimes> selectUserTimes(Long userId) {
        return appApiMapper.selectUserTimes(userId);
    }

    public List<Integer> getCheckApiList(Integer appId) {
        return appApiMapper.getCheckApiList(appId);
    }

    public List<AppApi> listAppApisByAppIdDev(Integer appId, Long userId) {
        return appApiMapper.listAppApisByAppIdDev(appId,userId);
    }

    public Integer getListByAppId(Integer appId) {
        return appApiMapper.getListByAppId(appId);
    }
}
